unit QuickRender;
{<|Author : Adler3D|>}
{<|e-mail : Adler3D@mail.ru|>}
{<|site : Adler3D.narod.ru|>}
interface
uses eXgine,OpenGL,QuickSprites,QuickList,TextSystem,ASDStream;

type
  TImageSystem=class(TObject)
  private
  public
    Image:TTexture;
    FW,FH:Integer;
    procedure Load(FN:string);
    procedure Render(X,Y:Real; ID,Mode:Integer);
    procedure RenderEx(X, Y: Real; ID, Mode: Integer);
  end;

  {TImage=class()
    Sys:TImageSystem;
    //rray
    procedure Draw(ID:Integer);
  end; }

implementation

uses SysUtils;

{ TImageSystem }

procedure TImageSystem.Load(FN:string);
{var
  F:TFileStream;
  Con:String;}
begin
  {F:=TFileStream.Create(FN,fmOpenRead);
  SetLength(Con,F.Size);
  F.ReadBuffer(Con[1],F.Size);
  F.Free;
  Con}
  Image:=tex.Load(PChar(FN)); FW:=1024; FH:=32;
end;

procedure TImageSystem.Render(X,Y:Real; ID,Mode:Integer);
const
  CS=24;
var
  CX,CY,OY,OX,MX,MY:Real;
begin
  CX:=CS/FW; CY:=CS/FH;
  OY:=4/FH;
  OX:=CX*ID;
  MX:=OX+CX; MY:=OY+CY;
  case Mode of
    6:
      begin
        CX:=OX; OX:=MX; MX:=CX;
      end;
    2:
      begin
        CY:=OY; OY:=MY; MY:=CY;
      end;
  end;
  glBegin(GL_QUADS);
  glTexCoord2d(OX,OY); glVertex2f(X,Y);
  glTexCoord2d(MX,OY); glVertex2f(X+CS,Y);
  glTexCoord2d(MX,MY); glVertex2f(X+CS,Y+CS);
  glTexCoord2d(OX,MY); glVertex2f(X,Y+CS);
  glEnd;
end;

procedure TImageSystem.RenderEx(X,Y:Real; ID,Mode:Integer);
const
  CS=24; CSd2=12;
var
  CX,CY,OY,OX,MX,MY:Real;
begin
  CX:=CS/FW; CY:=CS/FH;
  OY:=4/FH;
  OX:=CX*ID;
  MX:=OX+CX; MY:=OY+CY;
  case Mode of
    6:
      begin
        CX:=OX; OX:=MX; MX:=CX;
      end;
    2:
      begin
        CY:=OY; OY:=MY; MY:=CY;
      end;
  end;
  glBegin(GL_QUADS);
  glTexCoord2d(OX,OY); glVertex2f(X-CSd2,Y-CSd2);
  glTexCoord2d(MX,OY); glVertex2f(X+CSd2,Y-CSd2);
  glTexCoord2d(MX,MY); glVertex2f(X+CSd2,Y+CSd2);
  glTexCoord2d(OX,MY); glVertex2f(X-CSd2,Y+CSd2);
  glEnd;
end;

end.

