unit TextSystem;
{<|Author : Adler3D|>}
{<|e-mail : Adler3D@mail.ru|>}
{<|site : Adler3D.narod.ru|>}
interface
uses
  eXgine,OpenGL;

procedure DrawTextQ3(Font:TFont; X,Y:Real; S:string);
function TextQ3ToStr(S:string):string;
function TextQ3Len(Font:TFont; S:string):Integer;
function ScanParm(const Before,Where,After:string; var Pos:Integer):string;
function FToS(F:Extended; Width:Byte=0; Decimal:Byte=2):string;
function IToS(I:Integer; Width:Byte=0):string;
function KoiToWin(const S:string):string;
function PosEx(const SubStr,S:string; Offset:Cardinal=1):Integer;
implementation

//uses SysUtils;

function PosEx(const SubStr,S:string; Offset:Cardinal=1):Integer;
var
  I,X:Integer;
  Len,LenSubStr:Integer;
begin
  if Offset=1 then Result:=Pos(SubStr,S) else
  begin
    I:=Offset; LenSubStr:=Length(SubStr); Len:=Length(S)-LenSubStr+1;
    while I<=Len do
    begin
      if S[I]=SubStr[1] then
      begin
        X:=1;
        while (X<LenSubStr)and(S[I+X]=SubStr[X+1]) do Inc(X);
        if (X=LenSubStr) then
        begin
          Result:=I; exit;
        end;
      end;
      Inc(I);
    end;
    Result:=0;
  end;
end;

function HexToColor(S:string):TRGB;
const
  Num:set of Char= ['0'..'9'];
const
  O:Byte=Ord('0');
  A:Byte=Ord('A')-10;
var
  H,L:Byte;
begin
  if S[1]in Num then H:=Ord(S[1])-O else H:=Ord(UpCase(S[1]))-A;
  if S[2]in Num then L:=Ord(S[2])-O else L:=Ord(UpCase(S[2]))-A;
  Result.R:=H*16+L;
  if S[3]in Num then H:=Ord(S[3])-O else H:=Ord(UpCase(S[3]))-A;
  if S[4]in Num then L:=Ord(S[4])-O else L:=Ord(UpCase(S[4]))-A;
  Result.G:=H*16+L;
  if S[5]in Num then H:=Ord(S[5])-O else H:=Ord(UpCase(S[5]))-A;
  if S[6]in Num then L:=Ord(S[6])-O else L:=Ord(UpCase(S[6]))-A;
  Result.B:=H*16+L;
end;

function TextQ3Len(Font:TFont; S:string):Integer;
begin
  Result:=ogl.TextLen(Font,PChar(TextQ3ToStr(S)));
end;

function TextQ3ToStr(S:string):string;
const
  Num:set of Char= ['0'..'9'];
var
  I:Integer;
  T:string;
begin
  T:=''; Result:=''; I:=1;
  while I<=Length(S) do
  begin
    if S[I]='^' then
    begin
      Result:=Result+T;
      T:='';
      if I+1<=Length(S) then
      begin
        Inc(I);
        case S[I] of
          'x','X':if I+6<=Length(S) then Inc(I,6);
        end;
      end;
    end else T:=T+S[I]; Inc(I);
  end;
  Result:=Result+T;
end;

procedure DrawTextQ3(Font:TFont; X,Y:Real; S:string);
begin
  ogl.TextDraw(Font,Trunc(X),Trunc(Y),PChar(S));
end;

function KoiToWin(const S:string):string;
type
  TCC=array[#128..#255] of char;
const
  Koi2Win:TCC=(
    #128,#129,#130,#131,#132,#133,#134,#135,
    #136,#137,#138,#139,#140,#141,#142,#143,
    #144,#145,#146,#147,#148,#149,#150,#151,
    #152,#153,#218,#155,#176,#157,#183,#159,
    #160,#161,#162,#184,#186,#165,#166,#191,
    #168,#169,#170,#171,#172,#173,#174,#175,
    #156,#177,#178,#168,#170,#181,#182,#175,
    #184,#185,#186,#187,#188,#189,#190,#185,
    #254,#224,#225,#246,#228,#229,#244,#227,
    #245,#232,#233,#234,#235,#236,#237,#238,
    #239,#255,#240,#241,#242,#243,#230,#226,
    #252,#251,#231,#248,#253,#249,#247,#250,
    #222,#192,#193,#214,#196,#197,#212,#195,
    #213,#200,#201,#202,#203,#204,#205,#206,
    #207,#223,#208,#209,#210,#211,#198,#194,
    #220,#219,#199,#216,#221,#217,#215,#218);
var
  I:integer;
begin
  Result:=S;
  for I:=1 to Length(S) do if S[I]>#127 then Result[I]:=Koi2Win[S[I]];
end;

function ScanParm(const Before,Where,After:string; var Pos:Integer):string;
var
  E:Integer;
  //Deb:string;
begin
  if Length(Before)<>0 then Pos:=PosEx(Before,Where,Pos)+Length(Before);
  //Deb:=Copy(Where,Pos,200);
  E:=PosEx(After,Where,Pos);
  //Deb:=Copy(Where,Pos,200);
  Result:=Copy(Where,Pos,E-Pos);
  //if Deb='' then Pos:=0;
end;

function FToS(F:Extended; Width,Decimal:Byte):string;
begin
  Str(F:Width:Decimal,Result);
end;

function IToS(I:Integer; Width:Byte):string;
begin
  Str(I:Width,Result);
  for I:=0 to Length(Result) do if Result[I]=' ' then Result[I]:='0';
end;

end.

