unit ColideUnit;

interface
uses
  QuickSprites,GameScene,ASDVector;
type
  TColideProc=function(A,B:TEntity):Boolean;
function ColideEntity(E:TSpriteEngine; OnColide:TColideProc):Integer;
function DoPhisColide(A,B:TEntity):Boolean;
implementation

function ColideEntity(E:TSpriteEngine; OnColide:TColideProc):Integer;
var
  I,J:Integer;
  A,B:TEntity;
begin
  Result:=0;
  if Assigned(OnColide) then
  begin
    for I:=0 to E.Count-2 do
    begin
      A:=TEntity(E[I]);
      for J:=I+1 to E.Count-1 do
      begin
        B:=TEntity(E[J]);
        if VectorABDlina(A.P,B.P)<=A.R+B.R then
          if OnColide(A,B) then Inc(Result);
      end;
    end;
  end else
  begin
    for I:=0 to E.Count-2 do
    begin
      A:=TEntity(E[I]);
      for J:=I+1 to E.Count-1 do
      begin
        B:=TEntity(E[J]);
        if VectorABDlina(A.P,B.P)<=(A.R+B.R) then Inc(Result);
      end;
    end;
  end;
end;

{procedure CollisionBool(P1,P2:TVector; M1,M2:Real; var V1,V2:TVector);
var
  Buf:TVectorAngle;
  MyV,SpV:TVector;
  U1,U2,Alfa:Real;
  Va1,Va2:TVectorAngle;
begin
  Va1:=VectorToVectorAngle(V1);
  Va2:=VectorToVectorAngle(V2);
  MyV:=VectorSub(P2,P1);
  Alfa:=ArcTan2(MyV.Y,MyV.X);
  MyV.X:=Va1.Dlina*Cos((Va1.Alfa-Alfa));
  MyV.Y:=Va1.Dlina*Sin((Va1.Alfa-Alfa));
  SpV.X:=Va2.Dlina*Cos((Va2.Alfa-Alfa));
  SpV.Y:=Va2.Dlina*Sin((Va2.Alfa-Alfa));
  U1:=((M1-M2)*MyV.X+2*M2*SpV.X)/(M1+M2);
  U2:=((M2-M1)*SpV.X+2*M1*MyV.X)/(M1+M2);
  Buf:=VectorToVectorAngle(MakeVector(U1,MyV.Y));
  Va1.Alfa:=Buf.Alfa+Alfa;
  Va1.Dlina:=Buf.Dlina;
  Buf:=VectorToVectorAngle(MakeVector(U2,SpV.Y));
  Va2.Alfa:=Buf.Alfa+Alfa;
  Va2.Dlina:=Buf.Dlina;
  V1:=VectorAngleToVector(Va1);
  V2:=VectorAngleToVector(Va2);
end;}

function DoPhisColide(A,B:TEntity):Boolean;
var
  N:TVector;
  D,K:Real;
begin
  N:=VectorSub(A.P,B.P); D:=VectorMagnitude(N)-A.R-B.R; K:=4000;
  if D<>0 then
    N:=VectorSetDlina(N,D*D*D*K) else N:=NulVector;
  A.A:=VectorAdd(A.A,VectorDiv(N,-A.M));
  B.A:=VectorAdd(B.A,VectorDiv(N,+B.M));
  Result:=True;
end;

end.

