unit GameScene;
interface
uses
  Windows,eXgine,Scene,OpenGL,ASDVector,sys_main,QuickSprites,ASDLine;
type
  TGameScene=class(TScene)
  public
    constructor Init;
    procedure Render; override;
    procedure Update; override;
  end;

  { TEntity }
  TEntity=class(TSprite)
  protected
    procedure DoMove; override;
    procedure DoDraw; override;
  public
    {#<Field#}
    R:Real;
    C:TRGBA;
    M:Real;
    P:TVector;
    V:TVector;
    A:TVector;
    {#Field>#}
    procedure SetMass(Mass:Real);
    property AX:Real read A.X write A.X;
    property AY:Real read A.Y write A.Y;
    property VX:Real read V.X write V.X;
    property VY:Real read V.Y write V.Y;
    property PX:Real read P.X write P.X;
    property PY:Real read P.Y write P.Y;
  end;
var
  SE:TSpriteEngine;
implementation
uses
  GameRender,Tools,TextSystem,Global,ColideUnit;

{ TGameScene }

constructor TGameScene.Init;
var
  I{,W,H}:Integer;
  E:TEntity;
begin
  inherited Create('Game Scene'); Zoom:=1;
  SE:=TSpriteEngine.Create(nil);
  //W:=wnd.Width; H:=wnd.Height;
  for I:=1 to 20 do
  begin
    E:=TEntity.Create(SE);
    E.SetMass(200);
    //E.P:=MakeVector(RndReal(-W*2,W*2),RndReal(-H*2,H*2));
    E.P:=MakeVector(100*I,200);
    E.V:=MakeVectorEx(RndReal(-Pi,Pi),RndReal(0,100));
  end;
end;

procedure RenderNau;
const
  ED=16;
begin
  glPushMatrix;
  glTranslatef(222,333,0);
  tex.Enable(0); DrawQuad(0,0,10*ED,4*ED);
  tex.Enable(Img[1]); //DrawQuad(0,0,10*ED,4*ED);
  DrawQuad(-3*ED,+0*ED,2*ED*2,2*ED*2,0);
  DrawQuad(+3*ED,+0*ED,2*ED*2,2*ED*2,0);
  DrawQuad(+0*ED,+1*ED,1*ED*2,1*ED*2,0);
  DrawQuad(+0*ED,-1*ED,1*ED*2,1*ED*2,0);
  glPopMatrix;
end;

procedure TGameScene.Render;
begin
  ogl.Set2D(0,0,wnd.Width,wnd.Height); ogl.Clear;
  tex.Enable(Img[1]); ogl.Blend(BT_SUB);
  SE.Draw;
  //RenderNau;
  tex.Disable(0);
end;

procedure TGameScene.Update;
begin
  SE.Move; SE.Dead; ColideEntity(SE,DoPhisColide);
  if inp.Down(27) then eX.Quit;
end;

{ TEntity }

procedure TEntity.DoDraw;
begin
  DrawQuad(PX,PY,R*2,R*2,0);
end;

procedure TEntity.DoMove;
var
  dT:Real;
begin
  dT:=1/App.UPS;
  PX:=PX+VX*dT+AX*dT*dT/2; PY:=PY+VY*dT+AY*dT*dT/2; //calc Pos
  VX:=VX+AX*dT; VY:=VY+AY*dT; //calc velocity
  AX:=0; AY:=0; //calc Acceleration
end;

procedure TEntity.SetMass(Mass:Real);
const
  Ro=1;
begin
  M:=Mass;
  R:=Sqrt(Mass/(Ro*Pi));
end;

end.

