unit DDebug;

interface

uses
  DOS,
  DUtils;

type
TDebug = class
private
  FLogFile: string;
  procedure PrintToLogFile(S: TString);
  procedure ClearLogFile;
public
  constructor Create(LogFile: string = 'log.txt');
  procedure Log(Mes: TString);
  procedure Assert(Cond: Boolean; S: string = 'TDebug.Assert error');
end;

var
  SDebug: TDebug; // S = Singleton

implementation

//
//  TDebug
//
procedure TDebug.PrintToLogFile(S: TString);
  Var
    Data: TData;
begin
  if FLogFile = '' then
    Exit;
  Data := TData.Create(FLogFile); 
  Data.WriteVar(@S[1], Length(S));
  Data.WriteVar(@EOL[1], Length(EOL));
  Data.WriteToFile(FLogFile);
  Data.Free;
end;

procedure TDebug.ClearLogFile;
  var
    Data: TData;
begin
  if FLogFile = '' then
    Exit;
  Data := TData.Create;
  Data.WriteToFile(FLogFile);
  Data.Free;
end;

constructor TDebug.Create;
begin
  FLogFile := LogFile;
  ClearLogFile;
end;

procedure TDebug.Log(Mes: TString);
begin
  {$IFDEF FLAG_CONSOLE}
  Writeln(Mes);
  {$ENDIF}
  PrintToLogFile(Mes);
end;

procedure TDebug.Assert;
begin
end;

initialization
  SDebug := TDebug.Create;
finalization
  SDebug.Free;
end.
