unit u_mainform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ToolWin, ComCtrls, Menus, u_math, StdCtrls;

type
  TfrmMain = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    View1: TMenuItem;
    ZoomIn1: TMenuItem;
    Zoomout1: TMenuItem;
    ToolBar1: TToolBar;
    ST: TToolButton;
    Spoint: TToolButton;
    SaveDialog1: TSaveDialog;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Aster: TToolButton;
    FlyerBtn: TToolButton;
    Radius: TComboBox;
    MiniTurrel: TToolButton;
    Web: TToolButton;
    SX: TScrollBar;
    SY: TScrollBar;
    ToolButton4: TToolButton;
    btnCoin: TToolButton;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure STClick(Sender: TObject);
    procedure SpointClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ZoomIn1Click(Sender: TObject);
    procedure Zoomout1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure AsterClick(Sender: TObject);
    procedure FlyerBtnClick(Sender: TObject);
    procedure MiniTurrelClick(Sender: TObject);
    procedure WebClick(Sender: TObject);
    procedure SXChange(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ToolButton4Click(Sender: TObject);
    procedure btnCoinClick(Sender: TObject);
  private
    procedure UnpushBtns;
  public
    { Public declarations }
  end;

  TFileChunk = record
    ChankId : Word;
    DataLen : Word;
  end;

  TStartPointData = record
    Pos : TGamePos;
  end;

  TSimpleTurrData = record
    Pos : TGamePos;
  end;

var
  frmMain: TfrmMain;

  StartPoint : TGamePos;
  ZeroX, ZeroZ : Single;

  STurrels : array of TGamePos;
  Asteroids : array of record
    Radius : Single;
    Pos: TGamePos;
  end;
  Flyers : array of TGamePos;
  Minis : array of TGamePos;
  Webs  : array of TGamePos;
  Coins : array of TGamePos;

  Zoom : Single = 1;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
end;

procedure TfrmMain.FormPaint(Sender: TObject);
var
  i:Integer;
begin
  with Canvas do
  begin
    Brush.Color := clBlack;
    FillRect(GetClientRect);

    ZeroX := ClientWidth / 2 + (SX.Position * Zoom);
    ZeroZ := ClientHeight / 2 + (SY.Position * Zoom);

    Pen.Color := RGB(0, 100, 0);
    MoveTo(Trunc(ZeroX), 0);
    LineTo(Trunc(ZeroX), ClientHeight);

    MoveTo(0, Trunc(ZeroZ));
    LineTo(ClientWidth, Trunc(ZeroZ));

    Pen.Color := clLime;

    Rectangle(Trunc(ZeroX + (StartPoint.x - 1) * Zoom), Trunc(ZeroZ + (StartPoint.z - 1) * Zoom), Trunc(ZeroX + (StartPoint.x + 1) * Zoom), Trunc(ZeroZ + (StartPoint.z + 1) * Zoom));

    for i := 0 to High(STurrels) do
    begin
      Pen.Color := clRed;
      Brush.Style := bsClear;

      Ellipse(
        Trunc(ZeroX + (STurrels[i].x - 1) * Zoom),
        Trunc(ZeroZ + (STurrels[i].z - 1) * Zoom),
        Trunc(ZeroX + (STurrels[i].x + 1) * Zoom),
        Trunc(ZeroZ + (STurrels[i].z + 1) * Zoom)
      );

      //TextOut(Trunc(ZeroX + STurrels[i].x), Trunc(ZeroZ + STurrels[i].z), 'S');
    end;

    for i := 0 to High(Asteroids) do
    begin
      Pen.Color := clWhite;
      Brush.Style := bsClear;

      Ellipse(
        Trunc(ZeroX + (Asteroids[i].Pos.x - Asteroids[i].Radius) * Zoom),
        Trunc(ZeroZ + (Asteroids[i].Pos.z - Asteroids[i].Radius) * Zoom),
        Trunc(ZeroX + (Asteroids[i].Pos.x + Asteroids[i].Radius) * Zoom),
        Trunc(ZeroZ + (Asteroids[i].Pos.z + Asteroids[i].Radius) * Zoom)
      );
    end;

    for i := 0 to High(Flyers) do
    begin
      Pen.Color := clGreen;
      Brush.Style := bsSolid;

      Polygon([
        Point(Trunc( ZeroX + (Flyers[i].x - 0.5) * Zoom), Trunc( ZeroX + (Flyers[i].z + 0.5) * Zoom)),
        Point(Trunc( ZeroX + (Flyers[i].x) * Zoom), Trunc( ZeroX + (Flyers[i].z - 0.5) * Zoom)),
        Point(Trunc( ZeroX + (Flyers[i].x + 0.5) * Zoom), Trunc( ZeroX + (Flyers[i].z + 0.5) * Zoom))
      ]);
    end;

    for i := 0 to High(Minis) do
    begin
      Pen.Color := clMaroon;
      Brush.Style := bsClear;

      Ellipse(
        Trunc(ZeroX + (Minis[i].x - 1) * Zoom),
        Trunc(ZeroZ + (Minis[i].z - 1) * Zoom),
        Trunc(ZeroX + (Minis[i].x + 1) * Zoom),
        Trunc(ZeroZ + (Minis[i].z + 1) * Zoom)
      );

    end;

    for i := 0 to High(Webs) do
    begin
      Pen.Color := clNavy;
      Ellipse(
        Trunc(ZeroX + (Webs[i].x - 1) * Zoom),
        Trunc(ZeroZ + (Webs[i].z - 1) * Zoom),
        Trunc(ZeroX + (Webs[i].x + 1) * Zoom),
        Trunc(ZeroZ + (Webs[i].z + 1) * Zoom)
      );
    end;

    for i := 0 to High(Coins) do
    begin
      Pen.Color := clYellow;
      Ellipse(
        Trunc(ZeroX + (Coins[i].x - 0.5) * Zoom),
        Trunc(ZeroZ + (Coins[i].z - 0.5) * Zoom),
        Trunc(ZeroX + (Coins[i].x + 0.5) * Zoom),
        Trunc(ZeroZ + (Coins[i].z + 0.5) * Zoom)
      );
    end;
  end;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  Repaint;
end;

procedure TfrmMain.STClick(Sender: TObject);
begin
  UnpushBtns;
  ST.Down := True;
end;

procedure TfrmMain.SpointClick(Sender: TObject);
begin
  UnpushBtns;
  Spoint.Down := True;
end;

procedure TfrmMain.UnpushBtns;
var
  i:Integer;
begin
  for i := 0 to ToolBar1.ButtonCount-1 do
    ToolBar1.Buttons[i].Down := False;
end;

procedure TfrmMain.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if Spoint.Down then
  begin
    StartPoint.x := X - ZeroX;
    StartPoint.z := Y - ZeroZ;
  end;

  if ST.Down then
  begin
    SetLength(STurrels, length(STurrels)+1);
    STurrels[High(STurrels)].x := (X - ZeroX) / Zoom;
    STurrels[High(STurrels)].z := (Y - ZeroZ) / Zoom;
  end;

  if Aster.Down then
  begin
    SetLength(Asteroids, Length(Asteroids)+1);
    Asteroids[High(Asteroids)].Pos.x := (X - ZeroX) / Zoom;
    Asteroids[High(Asteroids)].Pos.z := (Y - ZeroZ) / Zoom;
    Asteroids[High(Asteroids)].Radius := StrToFloat(Radius.Text);
  end;

  if FlyerBtn.Down then
  begin
    SetLength(Flyers, Length(Flyers)+1);
    Flyers[High(Flyers)].x := (X - ZeroX) / Zoom;
    Flyers[High(Flyers)].z := (Y - ZeroX) / Zoom;
  end;

  if MiniTurrel.Down then
  begin
    SetLength(Minis, Length(Minis)+1);
    Minis[High(Minis)].x := (X - ZeroX) / Zoom;
    Minis[High(Minis)].z := (Y - ZeroZ) / Zoom;
  end;

  if Web.Down then
  begin
    SetLength(Webs, Length(Webs)+1);
    Webs[High(Webs)].x := (X - ZeroX) / Zoom;
    Webs[High(Webs)].z := (Y - ZeroZ) / Zoom;
  end;

  if btnCoin.Down then
  begin
    SetLength(Coins, Length(Coins)+1);
    Coins[High(Coins)].x := (X - ZeroX) / Zoom;
    Coins[High(Coins)].z := (Y - ZeroZ) / Zoom;
  end;


  Repaint;

  StatusBar1.Panels[0].Text := 'Coins: ' + IntToStr(Length(Coins));
end;

procedure TfrmMain.ZoomIn1Click(Sender: TObject);
begin
  Zoom := Zoom * 2;
  Repaint;
end;

procedure TfrmMain.Zoomout1Click(Sender: TObject);
begin
  Zoom := Zoom / 2;
  Repaint;
end;

procedure TfrmMain.Save1Click(Sender: TObject);
var
  FileChunk : TFileChunk;
  SPChunl : TStartPointData;
  STurrs : TSimpleTurrData;
  f: TextFile;
  i: Integer;
begin

  if SaveDialog1.Execute then
  begin
    AssignFile(f, SaveDialog1.FileName);
    Rewrite(f);

    Writeln(f, '0 Start');
    Writeln(f, StartPoint.x:3:3, ' ', StartPoint.z:3:3);

    Writeln(f, Length(STurrels), ' Turrels');

    for i := 0 to High(STurrels) do
    begin
      Writeln(f, STurrels[i].x:3:3, ' ', STurrels[i].z:3:3);
    end;

    Writeln(f, Length(Asteroids), ' Asteroids');

    for i := 0 to High(Asteroids) do
    begin
      Writeln(f, Asteroids[i].Radius:3:3, ' ', Asteroids[i].Pos.x:3:3, ' ', Asteroids[i].Pos.z:3:3);
    end;

    Writeln(f, Length(Flyers), ' Flyers');
    for i := 0 to High(Flyers) do
    begin
      Writeln(f, Flyers[i].x:3:3, ' ', Flyers[i].z:3:3);
    end;

    Writeln(f, Length(Minis), ' Mini');
    for i := 0 to High(Minis) do
    begin
      Writeln(f, Minis[i].x:3:3, ' ', Minis[i].z:3:3);
    end;

    Writeln(f, Length(Webs), ' Webs');
    for i := 0 to High(Webs) do
    begin
      Writeln(f, Webs[i].x:3:3, ' ', Webs[i].z:3:3);
    end;

    Writeln(f, Length(Coins), ' Coins');
    for i := 0 to High(Coins) do
    begin
      Writeln(f, Coins[i].x:3:3, ' ', Coins[i].z:3:3);
    end;

    Writeln(f, InputBox('Nex level?', 'Next level (0 - none)', '0'), ' Next');

    CloseFile(f);
  end;

end;

procedure TfrmMain.ToolButton2Click(Sender: TObject);
begin
ZoomIn1Click(Sender);
end;

procedure TfrmMain.ToolButton3Click(Sender: TObject);
begin
  Zoomout1Click(Sender);
end;

procedure TfrmMain.AsterClick(Sender: TObject);
begin
  UnpushBtns;
  Aster.Down := True;  
end;

procedure TfrmMain.FlyerBtnClick(Sender: TObject);
begin
  UnpushBtns;
  FlyerBtn.Down := True;
end;

procedure TfrmMain.MiniTurrelClick(Sender: TObject);
begin
  UnpushBtns;
  MiniTurrel.Down := True;
end;

procedure TfrmMain.WebClick(Sender: TObject);
begin
  UnpushBtns;
  Web.Down := True;
end;

procedure TfrmMain.SXChange(Sender: TObject);
begin
  Repaint;
end;

procedure TfrmMain.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  Zoom := Zoom + 1;
  if Zoom = 0 then Zoom := 1;
  Repaint;
end;

procedure TfrmMain.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  Zoom := Zoom - 1;
  if Zoom = 0 then Zoom := -1;
  Repaint;
end;

procedure TfrmMain.ToolButton4Click(Sender: TObject);
begin
  UnpushBtns;
end;

procedure TfrmMain.btnCoinClick(Sender: TObject);
begin
  UnpushBtns;
  btnCoin.Down := True;
end;

end.
