unit e_level2;

interface

procedure StageUpdate(count : single);
procedure ScriptSkip(full : boolean);
procedure RenderBack;
procedure RenderFront;

const NAME = 'to do'; 

implementation

uses OpenGL, e_global, e_models, e_textures, e_game, e_types, e_camera, e_utils, e_sound, e_particles,
     e_towers, e_lines, e_main;

var
  tower1  : TTower;
  object1, object2 : TObject;
  hints : array[1..3] of TLabel;
  back_shift : single = 0;

procedure ScriptUpdate(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0 : begin
        b := true;

        hints[1] := game.AddLabel('1.catch rocket', -9, -1.5, 5, false);
        hints[1].Show;
        hints[2] := game.AddLabel('2.move the wheel', 6, -3.5, 5, false);
        hints[3] := game.AddLabel('3.move on', 0, 6, 5, false);

        tower1 := game.AddTower(1, GetPoint(6, 0), -90);

        AddEnemy(1, GetPoint(-10, 0)).visible := 15;

        SetLength(game.objects, 20);

        object1 := game.AddObject(-7.5, 10, 0, 15, 2, texture_object1);
        object2 := game.AddObject(7.5, 10, 0, 15, 2, texture_object1);
        object1.Animate(-15, 10, 0, 1, 0);
        object1.animation_speed := -1;
        object2.Animate( 15, 10, 0, 1, 0);
        object2.animation_speed := -1;

        AddObject(-14, 0, 0, 2, 22, texture_object1);
        AddObject( 14, 0, 0, 2, 22, texture_object1);
        AddObject(0, -10, 0, 26, 2, texture_object1);

        CountObjects;
      end;
  1 : b := player.pos.x < -3;
  2 : begin
        hints[1].Hide;
        hints[2].Show;
        b := object1.pos.x < -8;
      end;
  3 : begin
        hints[2].Hide;
        hints[3].Show;
        b := player.pos.y > 12;
      end;
  4 : begin
        GameOver(true);
        exit;
      end;
end;

if b then
  inc(game.script);
end;

procedure ScriptSkip(full : boolean);
begin
end;

procedure StageUpdate(count : single);
var
p : TPoint;
s : single;
begin
ScriptUpdate(count);

object1.animation_speed := abs(tower1.speed / 15) * 0.2;
object2.animation_speed := abs(tower1.speed / 15) * 0.2;

clear_color := GetColor(0.7, 0.7, 0.7, 1);

back_shift := back_shift + count * 0.00005;
if back_shift > 1 then
  back_shift := back_shift - 1;
end;

procedure RenderBack;
begin
SetTexture(texture_back1);
glPushMatrix;
glScalef(30, 22, 1);

glColor4f(1, 1, 1, 0.5);
RotateTexture(10);
TranslateTexture(back_shift, 0);
ScaleTexture(30 / 10, 22 / 5);
glCallList(model_quad);
UnScaleTexture;
UnTranslateTexture;
UnRotateTexture;

glBlendFunc(GL_SRC_ALPHA, GL_ONE);
glColor4f(0.5, 0.5, 0.5, 0.5);
RotateTexture(-10);
TranslateTexture(-back_shift, 0);
ScaleTexture(-30 / 10, 22 / 5);
glCallList(model_quad);
UnScaleTexture;
UnTranslateTexture;
UnRotateTexture;
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

glPopMatrix;
end;

procedure RenderFront;
begin
end;

end.

