unit e_level3;

interface

procedure StageUpdate(count : single);
procedure ScriptSkip(full : boolean);
procedure RenderBack;
procedure RenderFront;

const NAME = 'greedy race'; 

implementation

uses OpenGL, e_global, e_models, e_textures, e_game, e_types, e_camera, e_utils,
     e_sound, e_particles, e_main, e_lines;

var
  corner1, corner2, object1 : TObject;
  progress : single;
  back_alpha : single = 0;

procedure ScriptUpdate(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0 : begin
        b := true;
        SetLength(game.objects, 20);

        bonuses_active := true;
        progress := 0;

        //SURVIVAL
        AddObject(-12, -8, 45, 2, 7, texture_object2);
        AddObject( 12, -8, -45, 2, 7, texture_object2);
        corner1 := AddObject( 12,  8, 45, 2, 13, texture_object2);
        corner2 := AddObject(-12,  8, -45, 2, 13, texture_object2);

        AddObject(-14.4, 0, 0, 2, 12, texture_object2);
        AddObject( 14.4, 0, 0, 2, 12, texture_object2);
        AddObject(0, -10.4, 0, 20, 2, texture_object2);
        object1 := AddObject(0,  10.4, 0, 20, 2, texture_object2);

        AddObject(5, 0, 30, 1, 14, texture_object2).AnimateRotation(1.7);
        AddObject(-5, 0, 30, 1, 14, texture_object2).AnimateRotation(-1.7);
        CountObjects;
      end;
  1 : b := player.score >= 15;
  2 : begin
        b := true;
        bonuses_active := false;
        corner1.Animate( 14.4, 8, 0, 1, 1.2);
        corner2.Animate(-14.4, 8, 0, 1, 1.2);
        object1.Animate(-4.5, 10.4, 0, 2, 1);
      end;
  3 : b := player.pos.y > 12;
  4 : begin
        GameOver(true);
        exit;
      end;
end;

if b then
  inc(game.script);
end;

procedure StageUpdate(count : single);
var
p : TPoint;
begin
ScriptUpdate(count);
Aspire(progress, game.player.score, count * 0.005);

clear_color := GetColor(0.5, 0.2, 0, 1);

back_alpha := back_alpha + count * 0.001;
if back_alpha > 360 then
  back_alpha := back_alpha - 360;
end;

procedure ScriptSkip(full : boolean);
begin
if game.script = 0 then
  ScriptUpdate(0);
end;

procedure RenderBack;
begin
SetTexture(texture_back2);
glPushMatrix;
glScalef(30, 22, 1);

glColor4f(0, 0, 0, 1);
ScaleTexture(30 / 5, 22 / 5);
glCallList(model_quad);
UnScaleTexture;

glPopMatrix;
end;

procedure RenderFront;
var
i : integer;
s : single;
begin
SetTexture(texture_bonus);
glColor4f(0.5, 0.5, 0.5, 1);

glPushMatrix;
glScalef(1.15, 1.15, 1);
glTranslatef(8, -7, 0);

for i := 15 downto 1 do
  begin
    s := progress - i + 1;
    if s > 1 then s := 1;
    if s < 0 then
      s := 0
    else
      glColor4f(0.5 + 0.5 * s, 0.5 + 0.3 * s, 0.5 - s * 0.5, 1);

    glTranslatef(-1, 0, 0);
    glCallList(model_quad);
  end;

glPopMatrix; 

glBlendFunc(GL_SRC_ALPHA, GL_ONE);
glPushMatrix;
glScalef(1.15, 1.15, 1);
glTranslatef(8, -7, 0);

for i := 15 downto 1 do
  begin
    s := progress - i + 1;
    if s > 1 then s := 1;
    glColor4f(1, 1, 1, s * 0.3);

    glTranslatef(-1, 0, 0);
    glCallList(model_quad);
  end;

glPopMatrix;
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
end;

end.

