unit e_level4;

interface

procedure StageUpdate(count : single);
procedure ScriptSkip(full : boolean);
procedure RenderBack;
procedure RenderFront;

const NAME = 'conterclockwork';

implementation

uses OpenGL, e_global, e_models, e_textures, e_game, e_types, e_camera, e_utils,
     e_sound, e_particles, e_main, e_lines, e_towers;

var
  tower1, tower2 : TTower;
  object1 : TObject;

procedure ScriptUpdate(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0 : begin
        b := true;
        SetLength(game.objects, 20);

        tower1 := AddTower(1, GetPoint(0, 0), -90);
        tower2 := AddTower(1, GetPoint(14, 0), 0);

        AddEnemy(3, GetPoint( 11,  7)); 
        AddEnemy(3, GetPoint(-11,  7));
        AddEnemy(2, GetPoint( 11, -7)).visible := 15;
        AddEnemy(2, GetPoint(-11, -7)).visible := 15;

        SetLength(game.objects, 20);
        AddObject(-14, 0, 0, 2, 22, texture_object1);
        AddObject( 14, 0, 0, 2, 22, texture_object1);
        AddObject(0, -10, 0, 26, 2, texture_object1);
        object1 := AddObject(0,  10, 0, 12, 2, texture_object1);
        object1.Animate(0, 5, 0, 1, 1);
        AddObject(-9.5,  10, 0, 7, 2, texture_object1);
        AddObject( 9.5,  10, 0, 7, 2, texture_object1);
        CountObjects;
      end;
  1 : b := player.pos.y > 12;
  2 : begin
        GameOver(true);
        exit;
      end;
end;

if b then
  inc(game.script);
end;

procedure StageUpdate(count : single);
var
p : TPoint;
begin
ScriptUpdate(count);

tower2.pos.x := tower2.pos.x - (tower1.speed + tower2.speed) * count * 0.00007;
if tower2.pos.x < 0 then
  tower2.pos.x := 0;
if tower2.pos.x > 14 then
  tower2.pos.x := 14;
tower1.pos.x := tower2.pos.x - 14;
object1.animation_speed := tower2.speed / 20;
end;

procedure ScriptSkip(full : boolean);
begin
if game.script = 0 then
  ScriptUpdate(0);
end;

procedure RenderBack;
begin
SetTexture(texture_back2);
glPushMatrix;
glScalef(30, 22, 1);
glColor4f(1, 1, 1, 0.5);
ScaleTexture(30 / 7, 22 / 7);
glCallList(model_quad);
UnScaleTexture;
glPopMatrix;

SetTexture(texture_arrow);
glColor4f(1, 1, 1, 0.7);

glPushMatrix;
with tower1.pos do
  glTranslatef(x, y - 2.1, 0);
glScalef(5, 2.5, 1);
glCallList(model_quad);
glPopMatrix;

glPushMatrix;
with tower2.pos do
  glTranslatef(x, y + 2.1, 0);
glScalef(-5, -2.5, 1);
glCallList(model_quad); 
glPopMatrix;
end;

procedure RenderFront;
begin
end;

end.

