unit e_level5;

interface

procedure StageUpdate(count : single);
procedure ScriptSkip(full : boolean);
procedure RenderBack;
procedure RenderFront;

const NAME = 'serpentine'; 

implementation

uses OpenGL, e_global, e_models, e_textures, e_game, e_types, e_camera, e_utils,
     e_sound, e_particles, e_main, e_lines;


const BONUSES_NUMBER = 30;

var
  progress, top : single;
  hints : array[1..6] of TLabel;
  object1 : TObject;

procedure ScriptUpdate(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0 : begin
        b := true;
        SetLength(game.objects, 20);

        hints[1] := Addlabel('i give you five tips', 0, 7, 5);
        hints[1].Show;

        hints[2] := Addlabel('1', -9, 3, 10);
        hints[3] := Addlabel('2', -6, 8, 10);
        hints[4] := Addlabel('3', 6, 8, 10);
        hints[5] := Addlabel('4', 9.5, 5, 10);
        hints[6] := Addlabel('5', 0, 0, 10);

        bonuses_active := true;
        progress := 0;
        top      := (progress / BONUSES_NUMBER - 0.5) * 16;

        AddEnemy(2, GetPoint(-12, 8)).visible := 8;
        AddEnemy(2, GetPoint( 12, -8)).visible := 8;
        AddEnemy(2, GetPoint( 12, 8)).visible := 8;
        AddEnemy(2, GetPoint(-12, -8)).visible := 8;

        //SURVIVAL
        AddObject(-14, 0, 0, 2, 22, texture_object1);
        AddObject( 14, 0, 0, 2, 22, texture_object1);
        AddObject(0, -10, 0, 26, 2, texture_object1);
        object1 := AddObject(0,  10, 0, 26, 2, texture_object1);


        AddObject(0, 4.5, 90, 1, 17, texture_object1);
        AddObject(0, -4.5, 90, 1, 17, texture_object1);
        AddObject(-8, 0, 90, 1, 10, texture_object1);
        AddObject(8, 0, 90, 1, 10, texture_object1);

        AddObject(2.5,  2, 0, 1, 4, texture_object1).Animate(2.5, -2, 0, 1, 1, true);
        AddObject(-2.5, -2, 0, 1, 4, texture_object1).Animate(-2.5, 2, 0, 1, 1, true);

        CountObjects;
      end;
  1 : b := Wait(0.5);
  2 : begin
        hints[2].Show;
        b := Wait(0.5);
      end;
  3 : begin
        hints[3].Show;
        b := Wait(0.5);
      end;
  4 : begin
        hints[4].Show;
        hints[1].Hide;
        b := Wait(0.5);
      end;
  5 : begin
        hints[5].Show;  
        b := Wait(0.5);
      end;
  6 : begin
        hints[6].Show;
        b := Wait(2);
      end;
  7 : begin
        hints[2].Hide;
        hints[3].Hide;
        hints[4].Hide;
        hints[5].Hide;
        hints[6].Hide;
        hints[1].text := 'don''t thanks';
        hints[1].Show;
        b := Wait(2);
      end;
  8 : begin
        hints[1].Hide;
        b := true;
      end;
  9 : b := player.score >= BONUSES_NUMBER;
  10: begin
        b := true;
        bonuses_active := false;
        object1.Animate(0, 15, 0, 2, 1);
      end;
  11: b := player.pos.y > 12;
  12: begin
        GameOver(true);
        exit;
      end;
end;

if b then
  inc(game.script);
end;

procedure StageUpdate(count : single);
var
p : TPoint;
begin
ScriptUpdate(count);
Aspire(progress, game.player.score, count * 0.005);

clear_color := GetColor(0.4, 0.4, 0.4, 1);

if game.script <= 9 then
  SqrAspire(top, (progress / BONUSES_NUMBER - 0.5) * 16, count * 0.02)
else
  SqrAspire(top, object1.pos.y - 2, count * 0.02);
end;

procedure ScriptSkip(full : boolean);
begin
if game.script = 0 then
  ScriptUpdate(0);
end;

procedure RenderBack;
begin
SetTexture(texture_back2);
glPushMatrix;
glScalef(30, 22, 1);
glColor4f(0, 0, 0, 1);
ScaleTexture(30 / 5, 22 / 5);
glCallList(model_quad);
UnScaleTexture;
glPopMatrix;

SetTexture(texture_back5);
glPushMatrix;
glTranslatef(0, top - 11, 0);
glScalef(30, 24, 1);
glColor4f(1, 1, 1, 1);
ScaleTexture(30 / 3, 24 / 3);
glCallList(model_quad);
UnScaleTexture;
glPopMatrix;

glColor4f(1, 1, 1, 0.7);
SetTexture(texture_object4);
glPushMatrix;
glTranslatef(0, top, 0);
glScalef(26, 2, 1);
ScaleTexture(26, 2);
glCallList(model_quad);
UnScaleTexture;
glPopMatrix;

glPushMatrix;
glTranslatef(-8, top - 12, 0);
glScalef(2, 22, 1);
ScaleTexture(2, 20);
glCallList(model_quad);
UnScaleTexture;
glPopMatrix;

glPushMatrix;
glTranslatef( 8, top - 12, 0);
glScalef(2, 22, 1);
ScaleTexture(2, 20);
glCallList(model_quad);
UnScaleTexture;
glPopMatrix;
end;

procedure RenderFront;
begin   
end;

end.

