#include <level.h>
#include <object.h>

#include <windows.h>
#include <stdio.h>
#include <Box2D.h>


CLevel::CLevel(CCore *engine,HGE *Hge,b2World *MyWorld) {
	hge = Hge;
	Engine = engine;
	World = MyWorld;
	ObjectManager = new CGameObjectManager(Engine,hge,World);
	texBg = hge->Texture_Load("data/graphics/arena.jpg");
	sprBg = new hgeSprite(texBg, 0, 0, hge->Texture_GetWidth(texBg), hge->Texture_GetHeight(texBg));
	sprBg->SetColor(0xffffffff);
	sprBg->SetHotSpot(hge->Texture_GetWidth(texBg)/2,hge->Texture_GetHeight(texBg)/2);
	fnt = new hgeFont("data/fnt/font1.fnt");
	GameInfo = new CGameInfo;
	bgMusic = hge->Music_Load("data/music/game.xm"); 
	sndAplause = hge->Effect_Load("data/sound/aplause.wav"); 
}

CLevel::~CLevel(void) {
	hge->Music_Free(bgMusic);
	delete ObjectManager;
	delete fnt;
	hge=0;
	World = NULL;
	Engine = NULL;
}

int CLevel::Update(float delta) {	
	bool flag = GameInfo->isGameOver;
	if (GameInfo->isGameOver == false) ObjectManager->Update(delta);
	if ((GameInfo->isGameOver)&&(!flag)) hge->Effect_Play(sndAplause);
	return 0;
}

void CLevel::Render(void) {
	hgeQuad quad;
	quad.blend = BLEND_DEFAULT;
	quad.tex = NULL;
	/*for(int i=0;i<4;i++) quad.v[i].z=0.5f;
	int iflag = 0;
	for(int i=0;i<8;i++)
	{
		if (iflag == 0) iflag = 1; else iflag = 0;
		for(int j=0;j<8;j++)
		{
			//   
			quad.v[0].x = 0.f+i*100.f;			quad.v[0].y = 0.f+j*75.f;
			quad.v[1].x = 0.f+i*100.f+100.f;	quad.v[1].y = 0.f+j*75.f;
			quad.v[2].x = 0.f+i*100.f+100.f;	quad.v[2].y = 0.f+j*75.f+75.f;
			quad.v[3].x = 0.f+i*100.f;			quad.v[3].y = 0.f+j*75.f+75.f;
			
			// 
			if (iflag == 0) iflag = 1; else iflag = 0;
			for(int i=0; i<4; i++)
			if (iflag == 0) quad.v[i].col = 0xFFffcc00;
			else quad.v[i].col=0xFF000000;

			hge->Gfx_RenderQuad(&quad);
		}
	}*/

	sprBg->Render(Engine->halfWidth, Engine->halfHeight);

	ObjectManager->Render();

	fnt->SetColor(0xff000000);
	fnt->printf(20.f,40.f,HGETEXT_LEFT,"score %d",GameInfo->Score);
	fnt->SetColor(0xffffffff);
	fnt->printf(20.f-3.f,40.f-3.f,HGETEXT_LEFT,"score %d",GameInfo->Score);
	
	if (GameInfo->isGameOver)
	{
		//   
		quad.blend = BLEND_DEFAULT;
		quad.v[0].x = 0;	quad.v[0].y = 0;
		quad.v[1].x = 800;	quad.v[1].y = 0;
		quad.v[2].x = 800;	quad.v[2].y = 600;
		quad.v[3].x = 0;	quad.v[3].y = 600;
		
		for(int i=0; i<4; i++) quad.v[i].col=0xaa444444;

		hge->Gfx_RenderQuad(&quad);


		fnt->SetColor(0xff000000);
		fnt->printf(400.f+3.f,50.f+3.f,HGETEXT_CENTER,"Press 'ESCAPE' to exit");
		fnt->SetColor(0xffffffff);
		fnt->printf(400.f,50.f,HGETEXT_CENTER,"Press 'ESCAPE' to exit");
		
		fnt->SetColor(0xff000000);
		fnt->printf(400.f+3.f,200.f+3.f,HGETEXT_CENTER,"SCORE %d",GameInfo->Score);
		fnt->SetColor(0xff55aaff);
		fnt->printf(400.f,200.f,HGETEXT_CENTER,"SCORE %d",GameInfo->Score);

		fnt->SetColor(0xff000000);
		fnt->printf(400.f+3.f,230.f+3.f,HGETEXT_CENTER,"Game over!!!");
		fnt->SetColor(0xffffffff);
		fnt->printf(400.f,230.f,HGETEXT_CENTER,"Game over!!!");

		fnt->SetColor(0xff000000);
		fnt->printf(400.f+3.f,270.f+3.f,HGETEXT_CENTER,"Thanks to all.");
		fnt->SetColor(0xffffffff);
		fnt->printf(400.f,270.f,HGETEXT_CENTER,"Thanks to all.");
		fnt->SetColor(0xff000000);
		fnt->printf(400.f+3.f,300.f+3.f,HGETEXT_CENTER,"programming: Soulghai");
		fnt->SetColor(0xffffffff);
		fnt->printf(400.f,300.f,HGETEXT_CENTER,"programming: Soulghai");
		fnt->SetColor(0xff000000);
		fnt->printf(400.f+3.f,330.f+3.f,HGETEXT_CENTER,"design: Ignis and Soulghai");
		fnt->SetColor(0xffffffff);
		fnt->printf(400.f,330.f,HGETEXT_CENTER,"design: Ignis and Soulghai");
	}

	fnt->SetColor(0xff000000);
	fnt->printf(Engine->Width-3*fnt->GetHeight(),Engine->Height-25,HGETEXT_RIGHT,"joy");
	fnt->SetColor(0xffffff00);
	fnt->printf(Engine->Width-3*fnt->GetHeight()-3.f,Engine->Height-25-3.f,HGETEXT_RIGHT,"joy");
	fnt->SetColor(0xff000000);
	fnt->printf(Engine->Width-3*fnt->GetHeight(),Engine->Height-25,HGETEXT_LEFT,"people");
	fnt->SetColor(0xff55aaff);
	fnt->printf(Engine->Width-3*fnt->GetHeight()-3.f,Engine->Height-25-3.f,HGETEXT_LEFT,"people");
}

bool CLevel::Load(void) {
	ObjectManager->DeleteAllObject();
	CGameObject *obj;
	ObjectManager->AddObject(obj = new CPlayer(hge,World,ObjectManager,GameInfo));
	
	ObjectManager->AddObject(obj = new CEnemyHeavy(hge,World,ObjectManager,GameInfo));
	obj->Add(hge->Random_Float(-20.f,-10.f), hge->Random_Float(0.f,60.f), 2.f);
	ObjectManager->AddObject(obj = new CEnemyHeavy(hge,World,ObjectManager,GameInfo));
	obj->Add(hge->Random_Float(90.f,100.f), hge->Random_Float(0.f,60.f), 2.f);
	ObjectManager->AddObject(obj = new CEnemyFast(hge,World,ObjectManager,GameInfo));
	obj->Add(hge->Random_Float(-20.f,-10.f), hge->Random_Float(0.f,60.f), 6.f);
	ObjectManager->AddObject(obj = new CEnemyFast(hge,World,ObjectManager,GameInfo));
	obj->Add(hge->Random_Float(90.f,100.f), hge->Random_Float(0.f,60.f), 6.f);

	hge->Music_Play(bgMusic,true);

	return true;
}
