#include "Player.h"

#include "../Omega/OMEGA_functions.h"
#include <windows.h>
#include <gl/gl.h>


const float tailSize = 2.0f;


Player :: Player ()
{ 
	health = 100.0f;
}

void Player :: render ()
{
	glPushMatrix();

	glTranslatef(p.x, p.y, 0.0f);

	glBindTexture ( GL_TEXTURE_2D, tex_player_inner );

	glColor4f(1.0f - health * 0.006f, pow(health * 0.01f, 2.0f), 0.0f, 1.0f );

	glBegin(GL_QUADS);
	glTexCoord2f(0.0f, 1.0f); glVertex2f( -playerSize, -playerSize);
	glTexCoord2f(0.0f, 0.0f); glVertex2f( -playerSize, playerSize);
	glTexCoord2f(1.0f, 0.0f); glVertex2f( playerSize, playerSize);
	glTexCoord2f(1.0f, 1.0f); glVertex2f( playerSize, -playerSize);
	glEnd();

	glColor4f ( 1.0f, 1.0f, 1.0f, 1.0f );



	glBindTexture ( GL_TEXTURE_2D, tex_player_outer );
	float angle = Angle ( v );
	glRotatef(angle * rad2deg, 0.0f, 0.0f, 1.0f);

	glBegin(GL_QUADS);
	glTexCoord2f(0.0f, 1.0f); glVertex2f( -playerSize, -playerSize);
	glTexCoord2f(0.0f, 0.0f); glVertex2f( -playerSize, playerSize);
	glTexCoord2f(1.0f, 0.0f); glVertex2f( playerSize, playerSize);
	glTexCoord2f(1.0f, 1.0f); glVertex2f( playerSize, -playerSize);
	glEnd();

	glPopMatrix();
}

void Player :: update ( float dt )
{
	p += v * dt;
	v = lerp ( v, vec2 ( 0.0f ), abs ( v ) * dt * 0.02f );
}

