#include "Resources.h"
#include "../Utils/Camera.h"

#include "../libTexture/TextureManager.h"
#include "../Sound/squall.h"

// 
unsigned int tex_cursor;
unsigned int tex_font;
unsigned int tex_button_normal;
unsigned int tex_button_roll;
unsigned int tex_false;
unsigned int tex_true;

unsigned int tex_player_inner;
unsigned int tex_player_outer;

unsigned int tex_enemy_1_inner;
unsigned int tex_enemy_2_inner;
unsigned int tex_enemy_outer;
unsigned int tex_enemy_3_inner;
unsigned int tex_enemy_3_tentacles;
unsigned int tex_enemy_4;
unsigned int tex_enemy_4_anim;
unsigned int tex_enemy_big;

unsigned int tex_bullet;
unsigned int tex_rocket;
unsigned int tex_rocket_big;
unsigned int tex_point;
unsigned int tex_splinter;
unsigned int tex_explosion;
unsigned int tex_electroshock;


// sound
int snd_background;
int snd_menu;

int snd_shock;
int snd_shock_shot;
int snd_plasma_shot;
int snd_bullet_shot;
int snd_plasma_charge;
int snd_rocket_shot;

int snd_bullet_hit;
int snd_enemy_die;
int snd_rocket_explosion;
int snd_slow_enable;
int snd_slow_disable;


// 

int WINDOW_WIDTH = 1024;
int WINDOW_HEIGHT = 768;
bool vSync;
bool fullScreen;

// 
float playerSize = 16.0f;
float enemysSize = 18.0f;
float enemyShockSize = 26.0f;

float enemy1MaxShootTime = 25.0f;			//   

float rocketSize = 14.0f;
float rocketSpeed = 5.0f;
float rocketBigSpeed = 8.0f;

float bulletSize = 10.0f;
float bulletSpeed = 5.0f;

float enemy1Speed = 2.0f;


void loadTextures()
{
	tex_cursor = textureManager.createTexture2D ( true, "Textures\\GUI\\cursor.png" );
	tex_font = textureManager.createTexture2D ( true, "Textures\\font.png" );
	tex_button_normal = textureManager.createTexture2D ( true, "Textures\\GUI\\button_normal.png" );
	tex_button_roll = textureManager.createTexture2D ( true, "Textures\\GUI\\button_roll.png" );
	tex_false = textureManager.createTexture2D ( true, "Textures\\GUI\\false.png" );
	tex_true = textureManager.createTexture2D ( true, "Textures\\GUI\\true.png" );


	tex_player_inner = textureManager.createTexture2D ( true, "Textures\\Game\\player_inner.png" );
	tex_player_outer = textureManager.createTexture2D ( true, "Textures\\Game\\player_outer.png" );

	tex_enemy_1_inner = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_1_inner.png" );
	tex_enemy_2_inner = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_2_inner.png" );
	tex_enemy_outer = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_outer.png" );
	tex_enemy_3_inner = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_3_inner.png" );
	tex_enemy_3_tentacles = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_3_tentacles.png" );
	tex_enemy_4 = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_4.png" );
	tex_enemy_4_anim = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_4_shock.png" );
	tex_enemy_big = textureManager.createTexture2D ( true, "Textures\\Game\\enemy_big.png" );

	tex_bullet = textureManager.createTexture2D ( true, "Textures\\Game\\bullet.png" );
	tex_rocket = textureManager.createTexture2D ( true, "Textures\\Game\\rocket.png" );
	tex_rocket_big = textureManager.createTexture2D ( true, "Textures\\Game\\rocket_big.png" );
	tex_point = textureManager.createTexture2D ( true, "Textures\\Game\\point.png" );
	tex_splinter = textureManager.createTexture2D ( true, "Textures\\Game\\splinter.png" );
	tex_explosion = textureManager.createTexture2D ( true, "Textures\\Game\\explosion.png" );
	tex_electroshock = textureManager.createTexture2D ( true, "Textures\\Game\\electroshock.png" );
}

void loadSounds()
{
	SQUALL_Init ( 0 );

	snd_background = SQUALL_Sample_LoadFile ( "Sounds\\theme.ogg", false, 0);
	snd_menu = SQUALL_Sample_LoadFile ( "Sounds\\menu.ogg", false, 0 );

	snd_shock = SQUALL_Sample_LoadFile ( "Sounds\\shock.ogg", true, 0 );
	snd_shock_shot = SQUALL_Sample_LoadFile ( "Sounds\\shock_shot.ogg", true, 0 );
	snd_plasma_shot = SQUALL_Sample_LoadFile ( "Sounds\\plasma_shot.ogg", true, 0 );
	snd_bullet_shot = SQUALL_Sample_LoadFile ( "Sounds\\bullet_shot.ogg", true, 0 );
	snd_plasma_charge = SQUALL_Sample_LoadFile ( "Sounds\\plasma_charge.ogg", true, 0 );
	snd_rocket_shot = SQUALL_Sample_LoadFile ( "Sounds\\rocket_shot.ogg", true, 0 );

	snd_bullet_hit = SQUALL_Sample_LoadFile ( "Sounds\\bullet_hit.ogg", true, 0 );
	snd_enemy_die = SQUALL_Sample_LoadFile ( "Sounds\\enemy_die.ogg", true, 0 );
	snd_rocket_explosion = SQUALL_Sample_LoadFile ( "Sounds\\rocket_explosion.ogg", true, 0 );
	snd_slow_enable = SQUALL_Sample_LoadFile ( "Sounds\\slow_enable.ogg", true, 0 );
	snd_slow_disable = SQUALL_Sample_LoadFile ( "Sounds\\slow_disable.ogg", true, 0 );
}

void unloadTextures()
{
}