#ifndef __COLLISIONS_H__
#define __COLLISIONS_H__

#include "vector.h"


class Circle;
class Line;


bool colLineCircle2(vec2& x1, vec2& x2, vec2& center, float radius, vec2* normal, float* depth);
bool colLineCircle(vec2& x1, vec2& x2, vec2& center, float radius, vec2* normal = NULL, float* depth = NULL);
vec2 closestPointOnLine(vec2& vA, vec2& vB, vec2& vPoint);
float lineDistance(vec2& a, vec2& b, vec2& c);


class Line
{
public:
	vec2 a;
	vec2 b;

public:
	Line(vec2& A, vec2& B):a(A), b(B){}
	bool lineIntersect(vec2& c, vec2& d);
	float pointDistance(vec2& c);
	float orient(vec2& c);					// ok
};

class Circle
{
public:
	vec2 center;
	float radius;

public:
	Circle(vec2& c, float r): center(c), radius(r){};
	bool colCircle(vec2& p, float r);					// ok
	bool colCircle(vec2& p, float r, vec2* depth);		// ok
	bool pointInside(vec2& p);							// ok
};


#endif

