#ifndef	__DATA__
#define	__DATA__

#pragma	warning (disable:4786 4996)

#include "String.h"

class Data
{
	unsigned char * bits;
	int				length;
	int				pos;
	String			file;

public:
	Data ( const char * fileName );
	Data ( const void * ptr, int len );

	void clear ()
	{
		free ( bits );
		bits = NULL;
		length = 0;
		pos = 0;
		file = "";
	}

	bool isOk () const;

	const String& getFileName () const
	{
		return file;
	}
	
	bool isEmpty () const
	{
		return pos >= length;
	}

	int	getLength () const
	{
		return length;
	}

	int	getPos () const
	{
		return pos;
	}

	int	getByte ()
	{
		if ( pos < length )
			return bits [pos++];
		else
			return -1;
	}

	signed short getShort ()
	{
		if ( pos + 1 >= length )
			return -1;

		signed short v = *(signed short *) (bits + pos);

		pos += 2;

		return v;
	}

	unsigned short getUnsignedShort ()
	{
		if ( pos + 1 >= length )
			return -1;

		unsigned short v = *(unsigned short *) (bits + pos);

		pos += 2;

		return v;
	}

	long getLong ()
	{
		if ( pos + 3 >= length )
			return -1;

		long 	v = *(long *) (bits + pos);

		pos += 4;

		return v;
	}

	unsigned long getUnsignedLong ()
	{
		if ( pos + 3 >= length )
			return -1;

		unsigned long v = *(unsigned long *) (bits + pos);

		pos += 4;

		return v;
	}

	float getFloat ()
	{
		if ( pos + 3 >= length )
			return 0;

		float f = *(float *)(bits + pos);

		pos += 4;

		return f;
	}

	double getDouble ()
	{
		if ( pos + 7 >= length )
			return 0;

		double d = *(double *)(bits + pos);

		pos += 8;

		return d;
	}

	void * getPtr () const
	{
		return bits + pos;
	}

	void * getPtr ( int offs ) const;

	int	seekCur ( int delta )
	{
		pos += delta;

		if ( pos > length )
			pos = length;

		if ( pos < 0 )
			pos = 0;

		return pos;
	}

	int	seekAbs ( int offs )
	{
		pos = offs;

		if ( pos > length )
			pos = length;

		if ( pos < 0 )
			pos = 0;

		return pos;
	}

	int		getBytes  ( void * ptr, int len );
	bool	getString ( String& str, char term );
};

#endif
