#include "Font.h"

const char font_text[]=" 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz.,:+-=()[]{}|\"!?#/\\%^*`<>@";


Font::Font()
{}

void Font::Init(int tex_id)
{
	texture = tex_id;

	int i, x, y;
	float wx, wy;

	kerning =  1.22f;

	list = glGenLists(strlen(font_text));

	wx = 1.0f / 16.0f;	//    
	wy = 1.0f / 16.0f;

	for (int i = 0; i < strlen(font_text); i++){
		x = i % 16;
		y = i / 16;
		
		float u = x * wx;
		float v = 1.0f - y * wy;	// 

		glNewList(list + i, GL_COMPILE);{
			glBegin(GL_QUADS);{
				glTexCoord2f(u, v);			  glVertex2f(0, 0);
				glTexCoord2f(u + wx, v);	  glVertex2f(1, 0);
				glTexCoord2f(u + wx, v - wy); glVertex2f(1, 1);
				glTexCoord2f(u, v - wy);	  glVertex2f(0, 1);
			} glEnd();   
		} glEndList();
	}
}

void Font::drawText(vec2& pos, float s, const char* text, float ker )
{
	if ( ker == -1 )
		kerning = s*0.02f;
	else
		kerning = ker;

	int i, p, a;

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glBindTexture(GL_TEXTURE_2D, texture);     
	glEnable(GL_TEXTURE_2D);

	glPushMatrix();
	glTranslatef(pos.x, pos.y, 0.0f);
	glScalef(s, s, 1.0f);

	a = 0;
	int len = strlen(text);
	for (int i = 0; i < len; i++){
		if ( text[i] == '\n' ){
			glTranslatef(-kerning*(float)(a), 1.0f, 0.0f);
			a = 0;
		}else{
			p = strpos(text[i], font_text);

			if (p > 0){
				glCallList(list + p);
			}

			a++;

			glTranslatef(kerning, 0.0f, 0.0f);
		}
	}

	glPopMatrix();
}


