// ----------------------------------------------------------
//  
//

#ifndef __PARTICLE_SYSTEM__
#define __PARTICLE_SYSTEM__

#include <math.h>
#include "../Math/Vector.h"
#include "Array.h"


void RenderQuad(vec2& v1, vec2& v2);


struct Particle
{
    vec2			 pos;			// 
    vec2			 speed;			//  
    float			 angle;			// 
    float	         angle_speed;	//  
    float			 life;			//  
    float		     start_life;	//  
    vec2			 size;			// 
};


class ParticlesEmitter
{
public:
    Array<Particle>  	particles;
	vec2				pos;
	bool				active; 
	vec3				color;  // 
    int					tex;    //  
   
	bool				back;	// 
    bool				loop;	//      )
    bool				alpha;	//   
public:
	ParticlesEmitter(vec2& p, vec3& col);
    virtual void ResetParticle(int i);
	virtual void UpdateParticle(int i, float dt);
	virtual void Update(float dt);
	virtual void Render(); 
};



class ParticlesEngine
{
public:
    Array<ParticlesEmitter*> emitters;	//  )

public:
	ParticlesEngine(){};
    int    AddEmitter(ParticlesEmitter* pm);//  
    void   DeleteEmitter(int i);		//  
	void   clear ();
    void   Update(float dt);			// ""
    void   RenderFront();				//  
	void   RenderBack();				// 
};


extern ParticlesEngine  particlesEngine;//  

#endif

