program Game;

uses
  OMEGA,
  Windows,
  OmegaPNG,
  OpenGL,
  Constans in 'Constans.pas',
  Gfx in 'Gfx.pas',
  Fonts in 'Fonts.pas',
  Scenes in 'Scenes.pas',
  scGame in 'scGame.pas',
  raPlayer in 'raPlayer.pas',
  Helper in 'Helper.pas',
  raEnemies in 'raEnemies.pas',
  raBullets in 'raBullets.pas',
  ogg in 'ogg.pas';

var
  Timer: POTimer;
  Music: TOGG;

procedure Process;
begin
  if scene = sc_Game then
  begin
    scGame.Update;
  end;

  if Key_Press(K_SNAPSHOT) then
    u_Snapshot('snapshots', pchar('snapshot_' + GAME_VERSION));
end;

procedure Draw;
begin
  if scene = sc_Game then
  begin
    scGame.Draw;
  end;

  //Text_Draw(fnt_Main, 8, 8, PChar('FPS: ' + U_IntToStr(OE_GetFPS)), 1, 0, 255, clBlack);

  //SSprite_Draw(tex_Cursor, Mouse_X, Mouse_Y, 32, 32);
end;

procedure Init;
begin
  glClearColor(1, 1, 1, 1);

  LoadFonts;
  LoadGfx;

  Randomize;
  OE_SetWndPosition((Windows.GetSystemMetrics(SM_CXSCREEN)-600) div 2, (Windows.GetSystemMetrics(SM_CYSCREEN)-600) div 2);
  OE_SetWndName('- ');

  OggInit(PDWORD(P_GetParams(gENGINE_HWND))^);
  Music := TOGG.Create('sound/MenuSong.ogg');
  Music.Play(true);

  scGame.Init;
  scene := sc_Game;
end;

procedure Quit;
begin
  Music.Free;
  Timer_Free(Timer);
end;

begin
  LoadOMEGA('OMEGA.dll');

  Timer := Timer_Create(@Process, 40);
  OE_RegProcedure(SYS_DRAW, @Draw);
  OE_RegProcedure(SYS_INIT, @Init);
  OE_RegProcedure(SYS_QUIT, @Quit);
  OE_SetScreenOptions(600, 600, 32, 0, false, false);
  OE_SetAdvancedOptions(true);
  OE_ShowCursor(false);
  OE_Init;
end.
