unit Helper;

interface
  uses Windows;

function OmegaColor(r, g, b: integer): integer;
function FloatToStr(Value: Single; Digits: LongInt = 6): string;

function GetSpeedX(x, y, x1, y1: single): single;
function GetSpeedY(x, y, x1, y1: single): single;

function GetDistance(x, y, x1, y1: single): single;

function Min(val1, val2: single): single;
function Max(val1, val2: single): single;

implementation

function OmegaColor;
begin
  Result := RGB(r, g, b);
end;

function FloatToStr;
begin
  Str(Value:0:Digits, Result);
end;

function GetSpeedX;
var
  gip: single;
begin
  gip := sqrt(sqr(x1-x) + sqr(y1-y));
  Result :=(x1-x)/gip;
end;

function GetSpeedY;
var
  gip: single;
begin
  gip := sqrt(sqr(x1-x) + sqr(y1-y));
  Result := (y1-y)/gip;
end;

function GetDistance(x, y, x1, y1: single): single;
begin
  Result := sqrt(sqr(x1-x) + sqr(y1-y));
end;

function Min;
begin
  Result := val1;
  if val2 < val1 then
    Result := val2;
end;

function Max;
begin
  Result := val1;
  if val2 > val1 then
    Result := val2;
end;

end.
