unit raBullets;

interface
  uses OMEGA, Helper, Gfx;

type
  TBullet = record
    X, Y: single;
    VelX, VelY: single;
    Dam: integer;
  end;

  {TRocket = record
    X, Y: single;
    target_player: boolean;
    VelX, VelY: single;
    kind: integer;
  end; }

  TNewRocket = record
    X, Y: single;
    phi: single;
    kind: integer;
    target_player: boolean;
    size: single;
    in_size: boolean;
    actTime: single;
  end;

var
  bullets: array of TBullet;

//  rockets: array of TRocket;

  nrs: array of TNewRocket;

procedure CreateBullet(X, Y, TX, TY, Vel: single; Dam: integer = 10);
procedure UpdateBullets;
procedure DrawBullets;

//procedure CreateRocket(X, Y: single; kind: integer = 0; target_player: boolean = true);

procedure CreateNewRocket(X, Y, Phi: single; kind: integer = 0; target_player: boolean = true);
procedure DrawNewRocket;
procedure UpdateNewRocket;

implementation
  uses raPlayer, raEnemies;

procedure CreateBullet;
begin
  SetLength(bullets, length(bullets)+1);
  bullets[length(bullets)-1].X := X;
  bullets[length(bullets)-1].Y := Y;
  bullets[length(bullets)-1].VelX := GetSpeedX(X, Y, TX, TY) * Vel;
  bullets[length(bullets)-1].VelY := GetSpeedY(X, Y, TX, TY) * Vel;
end;

procedure UpdateBullets;
var
  i: integer;
  DelBul: array of integer;
  c1, c2: TCircle2D;
begin
//  DelBul := -1;
  SetLength(DelBul, 0);
  c1.cX := player.GetPos.X; c1.cY := player.GetPos.Y; c1.Radius := player.GetSize;

  for i := 0 to length(bullets)-1 do
  begin
    bullets[i].X := bullets[i].X + bullets[i].VelX;
    bullets[i].Y := bullets[i].Y + bullets[i].VelY;

    if bullets[i].X > (OE_GetOptions.wnd_Width + 50) then
    begin
      SetLength(DelBul, length(DelBul)+1);
      DelBul[length(DelBul)-1] := i;
    end;
    if bullets[i].Y > (OE_GetOptions.wnd_Height + 50) then
    begin
      SetLength(DelBul, length(DelBul)+1);
      DelBul[length(DelBul)-1] := i;
    end;
    if bullets[i].X < -50 then
    begin
      SetLength(DelBul, length(DelBul)+1);
      DelBul[length(DelBul)-1] := i;
    end;
    if bullets[i].Y < -50 then
    begin
      SetLength(DelBul, length(DelBul)+1);
      DelBul[length(DelBul)-1] := i;
    end;

    c2.cX := bullets[i].X; c2.cY := bullets[i].Y; c2.Radius := 6;

    if Col_Circle(@c1, @c2) then
    begin
      player.Damage(10);

      SetLength(DelBul, length(DelBul)+1);
      DelBul[length(DelBul)-1] := i;
    end;

  end;

  for i := 0 to length(DelBul)-1 do
    if DelBul[i] <> -1 then
    begin
      bullets[DelBul[i]] := bullets[length(bullets)-1];
      SetLength(bullets, length(bullets)-1);
    end;

  SetLength(DelBul, 0);

{  DelBul := -1;

  for i := 0 to length(rockets)-1 do
  begin
    rockets[i].X := rockets[i].X + rockets[i].VelX * 6;
    rockets[i].Y := rockets[i].Y + rockets[i].VelY * 6;

    if rockets[i].target_player then
    begin
      rockets[i].VelX := GetSpeedX(rockets[i].X, rockets[i].Y, player.GetPos.X, player.GetPos.Y);
      rockets[i].VelY := GetSpeedY(rockets[i].X, rockets[i].Y, player.GetPos.X, player.GetPos.Y);
    end;

    if rockets[i].kind = 1 then    
      if GetDistance(rockets[i].X, rockets[i].Y, player.GetPos.X, Player.GetPos.Y) < 75 then
      begin
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X-1, rockets[i].Y, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X+1, rockets[i].Y, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X, rockets[i].Y-1, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X, rockets[i].Y+1, 10, 20);

        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X-1, rockets[i].Y-1, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X-1, rockets[i].Y+1, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X+1, rockets[i].Y-1, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X+1, rockets[i].Y+1, 10, 20);

        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X-2, rockets[i].Y-1, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X-2, rockets[i].Y+1, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X+2, rockets[i].Y-1, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X+2, rockets[i].Y+1, 10, 20);

        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X-1, rockets[i].Y-2, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X-1, rockets[i].Y+2, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X+1, rockets[i].Y-2, 10, 20);
        CreateBullet(rockets[i].X, rockets[i].Y, rockets[i].X+1, rockets[i].Y+2, 10, 20);

        DelBul := i;
      end;

  end;

  if DelBul <> -1 then
  begin
    rockets[DelBul] := rockets[length(rockets)-1];
    SetLength(rockets, length(rockets)-1);
  end; }
end;

procedure DrawBullets;
var
  i: integer;
begin
  for i := 0 to length(bullets)-1 do
    Pr2D_Circle(bullets[i].X, bullets[i].Y, 4, OmegaColor(128, 128, 255), 255, 32, PR_FILL);

  {for i := 0 to length(rockets)-1 do
    case rockets[i].kind of
      0: Pr2D_Circle(rockets[i].X, rockets[i].Y, 12, OmegaColor(0, 0, 0), 255, 32, PR_FILL);
      1: Pr2D_Circle(rockets[i].X, rockets[i].Y, 12, OmegaColor(128, 128, 128), 255, 32, PR_FILL);
    end; }
end;

{procedure CreateRocket(X, Y: single; kind: integer = 0; target_player: boolean = true);
begin
  SetLength(rockets, length(rockets)+1);
  rockets[length(rockets)-1].X := X;
  rockets[length(rockets)-1].Y := Y;
  rockets[length(rockets)-1].target_player := target_player;
  rockets[length(rockets)-1].kind := kind;
end; }

procedure CreateNewRocket;
begin
  SetLength(nrs, length(nrs)+1);
  nrs[length(nrs)-1].X := X;
  nrs[length(nrs)-1].Y := Y;
  nrs[length(nrs)-1].target_player := target_player;
  nrs[length(nrs)-1].kind := kind;
  nrs[length(nrs)-1].phi := Phi;
  nrs[length(nrs)-1].size := 0;
  nrs[length(nrs)-1].in_size := true;
  nrs[length(nrs)-1].actTime := U_GetTime;
end;

procedure DrawNewRocket;
var
  i: integer;
begin
  //SSprite_Draw(tex_cursor, nr.X, nr.Y, 32, 32, 255, nr.phi);
  for i := 0 to length(nrs)-1 do    
    case nrs[i].kind of
      0: Pr2D_Circle(nrs[i].X, nrs[i].Y, 12, OmegaColor(0, 0, 0), 255, 32, PR_SMOOTH);
      1: begin
        Pr2D_Circle(nrs[i].X, nrs[i].Y, nrs[i].size, OmegaColor(255, 128, 128), 255, 32, PR_SMOOTH);
        Pr2D_Circle(nrs[i].X, nrs[i].Y, 12, OmegaColor(128, 128, 128), 255, 32, PR_SMOOTH);
      end;
    end;
end;

procedure UpdateNewRocket;
var
  i, j: integer;
  DelBul: array of integer;
  c1, c2: TCircle2D;
begin
  //DelBul := -1;
  SetLength(DelBul, 0);
  for i := 0 to length(nrs)-1 do
  begin
    nrs[i].X := nrs[i].X + 6 * cos(nrs[i].phi * 3.14 / 180);
    nrs[i].Y := nrs[i].Y + 6 * sin(nrs[i].phi * 3.14 / 180);

    if nrs[i].target_player then
    begin
      if (nrs[i].phi < 60) and (M_FindAngle(Round(player.GetPos.X), Round(player.GetPos.Y), Round(nrs[i].X), Round(nrs[i].Y)) > 300) then
        nrs[i].phi := 360 - nrs[i].phi;
      if (nrs[i].phi > 300) and (M_FindAngle(Round(player.GetPos.X), Round(player.GetPos.Y), Round(nrs[i].X), Round(nrs[i].Y)) < 60) then
        nrs[i].phi := 360 - nrs[i].phi;

      if nrs[i].phi < M_FindAngle(Round(player.GetPos.X), Round(player.GetPos.Y), Round(nrs[i].X), Round(nrs[i].Y)) then
        nrs[i].phi := nrs[i].phi + 5;
      if nrs[i].phi > M_FindAngle(Round(player.GetPos.X), Round(player.GetPos.Y), Round(nrs[i].X), Round(nrs[i].Y)) then
        nrs[i].phi := nrs[i].phi - 5;
    end;

    if nrs[i].kind = 1 then
    begin
      if GetDistance(nrs[i].X, nrs[i].Y, player.GetPos.X, Player.GetPos.Y) < (nrs[i].size+10) then
      begin
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X-1, nrs[i].Y, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X+1, nrs[i].Y, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X, nrs[i].Y-1, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X, nrs[i].Y+1, 10, 20);

        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X-1, nrs[i].Y-1, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X-1, nrs[i].Y+1, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X+1, nrs[i].Y-1, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X+1, nrs[i].Y+1, 10, 20);

        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X-2, nrs[i].Y-1, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X-2, nrs[i].Y+1, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X+2, nrs[i].Y-1, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X+2, nrs[i].Y+1, 10, 20);

        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X-1, nrs[i].Y-2, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X-1, nrs[i].Y+2, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X+1, nrs[i].Y-2, 10, 20);
        CreateBullet(nrs[i].X, nrs[i].Y, nrs[i].X+1, nrs[i].Y+2, 10, 20);

        SetLength(DelBul, length(DelBul)+1);
        DelBul[length(DelBul)-1] := i;
      end;
      if nrs[i].in_size then
      begin
        if nrs[i].size < 50 then
          nrs[i].size := nrs[i].size + 1
        else
          nrs[i].in_size := false;
      end
      else
        if nrs[i].size > 12 then
          nrs[i].size := nrs[i].size - 1
        else
          nrs[i].in_size := true;
    end;

    // 
    if (U_GetTime - nrs[i].actTime) > 1000 then
    if nrs[i].kind = 0 then
    begin
      c2.cX := nrs[i].X; c2.cY := nrs[i].Y; c2.Radius := 12;

      c1.cX := player.GetPos.X; c1.cY := player.GetPos.Y; c1.Radius := player.GetSize;
      //  
      if Col_Circle(@c1, @c2) then
      begin
        SetLength(DelBul, length(DelBul)+1);
        DelBul[length(DelBul)-1] := i;

        player.Damage(20);
      end;
      //   
      for j := 0 to length(rcenters)-1 do
        if not rcenters[j].Die then        
      begin
        c1.cX := rcenters[j].GetPos.X; c1.cY := rcenters[j].GetPos.Y; c1.Radius := 16;

        if Col_Circle(@c1, @c2) then
        begin
          SetLength(DelBul, length(DelBul)+1);
          DelBul[length(DelBul)-1] := i;

          rcenters[j].Kill;
        end;
        
      end;
    end;

    if (U_GetTime - nrs[i].actTime) > 1000 then
      if nrs[i].kind = 1 then
      begin
        c2.cX := nrs[i].X; c2.cY := nrs[i].Y; c2.Radius := 12;
        //   
        for j := 0 to length(rcenters)-1 do
          if not rcenters[j].Die then          
        begin
          c1.cX := rcenters[j].GetPos.X; c1.cY := rcenters[j].GetPos.Y; c1.Radius := 16;

          if Col_Circle(@c1, @c2) then
           begin
            SetLength(DelBul, length(DelBul)+1);
            DelBul[length(DelBul)-1] := i;

            rcenters[j].Kill;
         end;
      end;
    end;
    
  end;

  for i := 0 to length(DelBul)-1 do    
    if DelBul[i] <> -1 then
    begin
      nrs[DelBul[i]] := nrs[length(nrs)-1];
      SetLength(nrs, length(nrs)-1);
    end;

  SetLength(DelBul, 0);
end;

end.
