﻿unit scGame;

interface
  uses OMEGA, uSpriteEngine, Gfx, raPlayer, Fonts, Constans, Helper, raEnemies,
    raBullets;

type
  THelpBox = (hbGrow, hbUnGrow, hbOff, hbShow);

procedure Init;
procedure Update;
procedure Draw;

var
  cufo: TCircleUFO;
  rcenter: TRocketCenter;
  level: integer;

  TurelsTimer: single;
  RCentersTimer: single;
  RCenters2Timer: single;

  LevelTimer: single;

  HelpBox: THelpBox;
  HelpBoxTime: single;
  hb_alpha: integer;

  cufos: array of TCircleUFO;

implementation

procedure Init;
begin
  player.Create(OE_GetOptions.wnd_Width / 2, OE_GetOptions.wnd_Height / 2);

//  cufo.Create(200, 200);
//  rcenter.Create(200, 200, 1);

  TurelsTimer := U_GetTime;
  level := 1;
  HelpBox := hbGrow;

  SetLength(bullets, 0);
//  SetLength(rockets, 0);
  SetLength(nrs, 0);

  SetLength(cufos, 0);
  SetLength(rcenters, 0);
end;

procedure Update;
var
  i: integer;
begin
  player.Update;

//  cufo.SetTarget(player.GetPos.X, player.GetPos.Y);
//  cufo.Update;
//  rcenter.Update;

  for i := 0 to length(cufos)-1 do
  begin
    cufos[i].SetTarget(player.GetPos.X, player.GetPos.Y);
    cufos[i].Update;
  end;
  for i := 0 to length(rcenters)-1 do
    rcenters[i].Update;

  UpdateNewRocket;

  UpdateBullets;

  case level of
    1: begin
      if length(cufos) < 10 then
      begin
        if (U_GetTime - TurelsTimer) > 6000 then
        begin
          SetLength(cufos, length(cufos)+1);
          cufos[length(cufos)-1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50));
          TurelsTimer := U_GetTime;
        end;
      end
      else
        if (U_GetTime - TurelsTimer) > 15000 then
        begin
          level := 2;
          HelpBox := hbGrow;
          SetLength(cufos, 0);
          LevelTimer := U_GetTime;
        end;
    end;
    2: begin
      if (U_GetTime - LevelTimer) > 6000 then
      if length(rcenters) < 4 then
      begin
        if length(rcenters) = 0 then
        begin
          SetLength(rcenters, 1);
          rcenters[0].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 0);
        end;
        if length(rcenters) = 1 then
        begin
          if rcenters[0].Die then
          begin
            SetLength(rcenters, 2);
            rcenters[1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 0);
          end;
        end;
        if length(rcenters) = 2 then
        begin
          if rcenters[1].Die then
          begin
            SetLength(rcenters, 3);
            rcenters[2].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 0);
          end;
        end;
        if length(rcenters) = 3 then
        begin
          if rcenters[2].Die then
          begin
            SetLength(rcenters, 4);
            TurelsTimer := U_GetTime;
          end;
        end;
      end
      else
        if (U_GetTime - TurelsTimer) > 1000 then
        begin
          level := 3;
          HelpBox := hbGrow;
          SetLength(rcenters, 0);
          LevelTimer := U_GetTime;
          TurelsTimer := U_GetTime-1000;
          RCentersTimer := U_GetTime-9000;
        end;
    end;
    3: begin
      if (U_GetTime - LevelTimer) < 120000 then
      begin
        if (U_GetTime - TurelsTimer) > 6000 then
        begin
          SetLength(cufos, length(cufos)+1);
          cufos[length(cufos)-1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50));
          TurelsTimer := U_GetTime;
        end;
        if (U_GetTime - RCentersTimer) > 12000 then
        begin
          SetLength(rcenters, length(rcenters)+1);
          rcenters[length(rcenters)-1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 0);
          RCentersTimer := U_GetTime;
        end; 
      end
      else
      begin
        for i := 0 to length(cufos)-1 do
          cufos[i].Kill;
        for i := 0 to length(rcenters)-1 do
          if not rcenters[i].Die then
           rcenters[i].Kill;
        if (U_GetTime - LevelTimer) > 121000 then
        begin
          level := 4;
          HelpBox := hbGrow;
          SetLength(cufos, 0);
          SetLength(rcenters, 0);
          SetLength(nrs, 0);
          LevelTimer := U_GetTime;
        end;
      end;
    end;
    4: begin
      if (U_GetTime - LevelTimer) > 6000 then      
      if length(rcenters) < 4 then
      begin
        if length(rcenters) = 0 then
        begin
          SetLength(rcenters, 1);
          rcenters[0].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 1);
        end;
        if length(rcenters) = 1 then
        begin
          if rcenters[0].Die then
          begin
            SetLength(rcenters, 2);
            rcenters[1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 1);
          end;
        end;
        if length(rcenters) = 2 then
        begin
          if rcenters[1].Die then
          begin
            SetLength(rcenters, 3);
            rcenters[2].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 1);
          end;
        end;
        if length(rcenters) = 3 then
        begin
          if rcenters[2].Die then
          begin
            SetLength(rcenters, 4);
            TurelsTimer := U_GetTime;
          end;
        end;
      end
      else
        if (U_GetTime - TurelsTimer) > 3000 then
        begin
          level := 5;
          HelpBox := hbGrow;
          SetLength(rcenters, 0);
          LevelTimer := U_GetTime;
          TurelsTimer := U_GetTime-4000;
          RCentersTimer := U_GetTime-9000;
          RCenters2Timer := U_GetTime-9000;
        end;    
    end;
    5: begin
      if (U_GetTime - LevelTimer) < 180000 then
      begin
        if (U_GetTime - TurelsTimer) > 5000 then
        begin
          SetLength(cufos, length(cufos)+1);
          cufos[length(cufos)-1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50));
          TurelsTimer := U_GetTime;
        end;
        if (U_GetTime - RCentersTimer) > 12000 then
        begin
          SetLength(rcenters, length(rcenters)+1);
          rcenters[length(rcenters)-1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 0);
          RCentersTimer := U_GetTime;
        end;
        if (U_GetTime - RCenters2Timer) > 15000 then
        begin
          SetLength(rcenters, length(rcenters)+1);
          rcenters[length(rcenters)-1].Create(Min(Max(50, Random(OE_GetOptions.wnd_Width)), OE_GetOptions.wnd_Width-50), Min(Max(50, Random(OE_GetOptions.wnd_Height)), OE_GetOptions.wnd_Height-50), 1);
          RCenters2Timer := U_GetTime;
        end; 
      end
      else
      begin
        for i := 0 to length(cufos)-1 do
          cufos[i].Kill;
        for i := 0 to length(rcenters)-1 do
          if not rcenters[i].Die then
           rcenters[i].Kill;
        if (U_GetTime - LevelTimer) > 183000 then
        begin
          level := 6;
          HelpBox := hbGrow;
          SetLength(cufos, 0);
          SetLength(rcenters, 0);
          SetLength(nrs, 0);
        end;
      end;    
    end;
  end;

  if level <> 6 then  
    if player.GetHealth < 0 then
    begin
      SetLength(cufos, 0);
      SetLength(rcenters, 0);
      SetLength(nrs, 0);

      level := 6;
      hb_alpha := 0;
      HelpBox := hbGrow;
    end;

  case HelpBox of
    hbGrow: if hb_alpha < 250 then hb_alpha := hb_alpha + 4 else begin hb_alpha := 255; HelpBox := hbShow; HelpBoxTime := U_GetTime; end;
    hbShow: if (U_GetTime - HelpBoxTime) > 10000 then HelpBox := hbUnGrow;
    hbUnGrow: if hb_alpha > 5 then hb_alpha := hb_alpha - 4 else begin hb_alpha := 0; HelpBox := hbOff; end;
    hbOff: ;
  end;

  if Key_Press(K_Q) then
    HelpBox := hbGrow;


  if Key_Press(K_ESCAPE) then
    OE_Quit;
end;

procedure DrawTextBox(x, y, w: single; text: string);
var
  txt, str, lstr: string;
  i, j: integer;
begin
  //Text_Draw(fnt_Main, x, y, PChar(text), 1, 0, 255, clBlack);

  j := 0;
  str := text;
  lstr := '';
  i := 0;
  while i < length(text)-1 do
  begin
    if text[i] = '^' then
      if text[i+1] = 'N' then
      begin

        txt := Copy(str, 0, i-1-length(lstr));
        Text_Draw(fnt_Main, x, y+j*16, PChar(txt), 1, 0, hb_alpha, OmegaColor(255, 128, 164));
        lstr := lstr + '^N' + txt;

        j := j + 1;

        str := Copy(text, length(lstr)+1, length(text));
      end;
      i := i + 1;
  end;
end;

procedure DrawHint;
var
  hint_text: string;
begin
  Text_Draw(fnt_Main, (OE_GetOptions.wnd_Width - 300) + (300 - Text_GetWidth(fnt_Main, 'Уровень 1')) / 2, 8, PChar('Уровень ' + U_IntToStr(level)), 1, 0, 255, OmegaColor(164, 164, 255));
  Text_Draw(fnt_Main, 75, 80, 'Q - помощь', 1, 0, 255, OmegaColor(164, 164, 255));
  Text_Draw(fnt_Main, 75, 100, 'Esc - выход', 1, 0, 255, OmegaColor(164, 164, 255));

  case level of
    1: begin
      hint_text := '  Привет, игрок!^N^N' +

                    'Зелёный кружочек - это твой альтер-эго.^N' +
                    '                                    Управляй им, клацая WASD.^N^N' +

                    'Жёлтый - вражеская турель.^N' +
                    'Такие турели будут мешать тебе всю игру,^N' +
                    '                                          появляясь то тут, то там.^N' +
                    'Постреляют немного и исчезнут.^N' +
                    'Стреляют они прямолетящими *синими* кружками.^N^N' +
                    
                    'Твоя задача:^N' +
                    '  уклоняться от этих самых *синих* кружочков-пуль.^N^N' +
                    'Удачи!^N ';
                    // Осталось турелей: 10 - length(cufos)
      Text_Draw(fnt_Main, (OE_GetOptions.wnd_Width - 300) + (300 - Text_GetWidth(fnt_Main, PChar('Ещё противников: ' + U_IntToStr(10-length(cufos))))) / 2, 24, PChar('Ещё противников: ' + U_IntToStr(10-length(cufos))), 1, 0, 255, OmegaColor(164, 164, 255));
      if (HelpBox <> hbOff) then
        DrawTextBox(OE_GetOptions.wnd_Width - 320, 40, 300, hint_text);
    end;
  2: begin
    hint_text := '  Ого-го! Ты удачно с правился со своей задачей^Nи перешёл на второй уровень!^N^N' +

                  'Теперь твои противники стали больше и круче!^N' +
                  'Осторожнее с этими розовыми кружочками^N                                                - они опасные враги!^N' +
                  'Они - это ракетные комплексы.^N                             Не ЗРК, конечно, но тоже крутые.^N' +
                  'Стреляют самонаводящимися белыми кружочками.^N^N' +

                  'Твоя задача:^N  избегать столкновения с кружочками-ракетами^N  и попытаться столкнуть их с ракетным комплексом.^N^N' +

                  'Удачи!^N ';
                  // Осталось ракетных станций: 3 - length(rcenters)
    Text_Draw(fnt_Main, (OE_GetOptions.wnd_Width - 300) + (300 - Text_GetWidth(fnt_Main, PChar('Ещё противников: ' + U_IntToStr(3-length(rcenters))))) / 2, 24, PChar('Ещё противников: ' + U_IntToStr(3-length(rcenters))), 1, 0, 255, OmegaColor(164, 164, 255));
    if (HelpBox <> hbOff) then
      DrawTextBox(OE_GetOptions.wnd_Width - 320, 40, 300, hint_text);
  end;
  3: begin
    hint_text := 'Поздравляю, ты прошёл второй уровень!^NВпереди третий, ага.^N^N' +
                  'Новых врагов нет.^NЗато много старых, и они очень злые.^N^N' +
                  'Продержись две минуты.^N^N' +
                  'Удачи!^N ';
                  // Осталось .. секунд
    Text_Draw(fnt_Main, (OE_GetOptions.wnd_Width - 300) + (300 - Text_GetWidth(fnt_Main, PChar('Осталось ' + FloatToStr((LevelTimer+120000-U_GetTime)/1000, 0) + ' секунд'))) / 2, 24, PChar('Осталось ' + FloatToStr((LevelTimer+120000-U_GetTime)/1000, 0) + ' секунд'), 1, 0, 255, OmegaColor(164, 164, 255));
    if (HelpBox <> hbOff) then
      DrawTextBox(OE_GetOptions.wnd_Width - 320, 40, 300, hint_text);
  end;
  4: begin
    hint_text := 'Да ты крут! Но дальше труднее. Не расслабляться!^N^N' +
                  'Новая разновидность ракетных комплексов!^N' +
                  'Они поменяли окраску и боезапас!^N' +
                  'Теперь стреляют самонаводящимися кружками,^N    взрывающимися рядом с твоим зелёным другом.^N^N' +
                  'Тактика борьбы не изменилась:^N  столкни кружки-ракеты с ракетными комплексами.^N^N' +
                  'Удачи!^N ';
                  // Осталось ракетных станций: 3 - length(rcenters)
    Text_Draw(fnt_Main, (OE_GetOptions.wnd_Width - 300) + (300 - Text_GetWidth(fnt_Main, PChar('Ещё противников: ' + U_IntToStr(3-length(rcenters))))) / 2, 24, PChar('Ещё противников: ' + U_IntToStr(3-length(rcenters))), 1, 0, 255, OmegaColor(164, 164, 255));
    if (HelpBox <> hbOff) then
      DrawTextBox(OE_GetOptions.wnd_Width - 320, 40, 300, hint_text);
  end;
  5 : begin
    hint_text := 'Ну всё, последний уровень.^N^N' +
                  'Продержись три минуты и ты станешь мастером!^N^N' +
                  'И да прибудет с тобой сила!^N ';
                  // Осталось .. секунд
    Text_Draw(fnt_Main, (OE_GetOptions.wnd_Width - 300) + (300 - Text_GetWidth(fnt_Main, PChar('Осталось ' + FloatToStr((LevelTimer+180000-U_GetTime)/1000, 0) + ' секунд'))) / 2, 24, PChar('Осталось ' + FloatToStr((LevelTimer+180000-U_GetTime)/1000, 0) + ' секунд'), 1, 0, 255, OmegaColor(164, 164, 255));
    if (HelpBox <> hbOff) then
      DrawTextBox(OE_GetOptions.wnd_Width - 320, 40, 300, hint_text);
  end;
  6: begin
    hint_text := 'Игра окончена. Спасибо.^N^N' +
                  'Отзывы, благодарности и помидоры:^N  - в дневник (beisik.livejournal.com)^N  - на мыло (fbeisik@gmail.com)^N  - и аську (310-783-871).^N' +
                  'Буду очень рад :)^N^N' +
                  'Приветы:^N OUEO factory, ViZgl, Adler, Doj,^N Joel, Lampogolovii, KEFIR, Soulghai^N^N' +
                  'Дави ЭСКЕЙП!^N ';
    if (HelpBox <> hbOff) then
      DrawTextBox(OE_GetOptions.wnd_Width - 320, 40, 300, hint_text);
  end;
  end;
end;

procedure Draw;
var
  i: integer;
begin
  SSprite_Draw(tex_IGDC, 0, 0, 512, 512);

  DrawHint;

//  cufo.Draw;
//  rcenter.Draw;
  for i := 0 to length(cufos)-1 do
    cufos[i].Draw;
  for i := 0 to length(rcenters)-1 do
    rcenters[i].Draw;

  DrawNewRocket;

  player.Draw;

  DrawBullets;

  for i := 0 to (player.GetHealth div 10) do
  begin
    Pr2D_Circle(OE_GetOptions.wnd_Width - i * 8 - 10, OE_GetOptions.wnd_Height - 10, 2, OmegaColor(128, 255, 128), 255, 32, PR_FILL);
    Pr2D_Circle(OE_GetOptions.wnd_Width - i * 8 - 10, OE_GetOptions.wnd_Height - 10, 3, OmegaColor(255, 128, 128), 255, 32, PR_SMOOTH);
  end;

  {
  Text_Draw(fnt_Main, 8, OE_GetOptions.wnd_Height - 48, 'Параметры игрока:', 1, 0, 255, clBlack);
  Text_Draw(fnt_Main, 8, OE_GetOptions.wnd_Height - 32, PChar('Поз. X: ' + FloatToStr(player.GetPos.X, 1) + '; Поз. Y: ' + FloatToStr(player.GetPos.Y, 1) + '; Уск. X: ' + FloatToStr(player.GetVel.X, 1) + '; Уск. Y: ' + FloatToStr(player.GetVel.Y, 1)), 1, 0, 255, clBlack);
  Text_Draw(fnt_Main, 8, OE_GetOptions.wnd_Height - 16, PChar('Хелсы: ' + U_IntToStr(player.GetHealth)), 1, 0, 255, clBlack);

  Text_Draw(fnt_Main, OE_GetOptions.wnd_Width - 150, OE_GetOptions.wnd_Height - 96, PChar('Отладка:'), 1, 0, 255, clBlack);
  Text_Draw(fnt_Main, OE_GetOptions.wnd_Width - 150, OE_GetOptions.wnd_Height - 80, PChar('Кол-во пуль: ' + U_IntToStr(length(bullets))), 1, 0, 255, clBlack);
  Text_Draw(fnt_Main, OE_GetOptions.wnd_Width - 150, OE_GetOptions.wnd_Height - 64, PChar('Кол-во ракет: ' + U_IntToStr(length(nrs))), 1, 0, 255, clBlack);
  }
end;

end.
